{$APPTYPE CONSOLE}

{$R+,Q+}
const
    maxn = 200;
    maxm = 2000;

var
    i, j, p, q, n, m, k, e, a, b, l: longint;
    head: array [1..maxn] of longint;
    phi: array [1..maxn] of longint;
    c, f, src, dst, rev, len, slen, next: array [1..2*maxm] of longint;
    u, v: array [1..maxn] of boolean;
    d: array [1..maxn] of longint;
    from: array [1..maxn] of longint;
    path: array [1..maxn] of longint;
    fail: boolean;
    sum: longint;
    max, dt: longint;

begin
    assign(input, 'brides.in');
    reset(input);
    assign(output, 'brides.out');
    rewrite(output);

    read(n);
    read(m);
    read(k);
    e := 0;
    for i := 1 to m do begin
        read(a, b, l);

        inc(e);      
        next[e] := head[a];
        head[a] := e;
        src[e] := a;
        dst[e] := b;
        c[e] := 1;
        f[e] := 0;
        rev[e] := e + 1;
        len[e] := l;
        slen[e] := l;

        inc(e);
        next[e] := head[b];
        head[b] := e;
        src[e] := b;
        dst[e] := a;
        c[e] := 1;
        f[e] := 0;
        rev[e] := e - 1;
        len[e] := l;
        slen[e] := l;
    end;

    fail := false;
    for i := 1 to k do begin
        fillchar(u, sizeof(u), 0);
        fillchar(v, sizeof(v), 0);
        d[1] := 0;
        v[1] := true;
        max := 0;
        while true do begin
            p := 0;
            for q := 1 to n do begin
                if v[q] and not u[q] and ((p = 0) or (d[q] < d[p])) then
                    p := q;
            end;
            if p = 0 then break;

            u[p] := true;
            max := d[p];

            j := head[p];
            while j <> 0 do begin
                if c[j] > f[j] then begin
                    q := dst[j];
                    dt := d[p] + phi[p] - phi[q];
                    if f[j] < 0 then
                        dt := dt - len[j]
                    else
                        dt := dt + len[j];
                    if not v[q] or (d[q] > dt) then begin
                        d[q] := dt;
                        v[q] := true;
                        from[q] := j;
                    end;
                end;
                j := next[j];
            end;
        end;

        for j := 1 to n do begin
            if not v[j] then
                d[j] := max;
        end;

        if not v[n] then begin
            fail := true;
            break;
        end;

        p := n;
        while p <> 1 do begin
            inc(f[from[p]]);
            dec(f[rev[from[p]]]);
            p := src[from[p]];
        end;

        for j := 1 to n do begin
            phi[j] := phi[j] + d[j];
        end;
    end;

    if fail then begin
        writeln(-1);
    end else begin
        sum := 0;
        for i := 1 to e do begin
            if f[i] > 0 then
                sum := sum + slen[i];
        end;

        writeln(sum / k :0 :5);

        for i := 1 to k do begin
            p := 1;
            l := 0;
            while p <> n do begin
                j := head[p];
                while j <> 0 do begin
                    if f[j] > 0 then begin
                        f[j] := 0;
                        inc(l);
                        path[l] := j;
                        p := dst[j];
                        break;
                    end;
                    j := next[j];
                end;
            end;
            write(l);
            for j := 1 to l do begin
                write(' ', (path[j] + 1) div 2);
            end;
            writeln;
        end;
    end;

    close(input);
    close(output);
end.